import { VNodeChildElement } from './renderer';
interface BaseProps {
    defaultSlot?: VNodeChildElement | VNodeChildElement[];
}
declare type Data<T> = {
    [K in keyof T]: T[K];
};
export interface WebCellComponent<P extends BaseProps = {}, S = {}> extends Element {
    connectedCallback(): void;
    attributeChangedCallback?(name: string, oldValue: string, newValue: string): void;
    adoptedCallback?(): void;
    disconnectedCallback?(): void;
    props: Data<P>;
    setProps(data: {
        [key in keyof P]: any;
    }): Promise<void>;
    state: Data<S>;
    setState(data: {
        [key in keyof S]: any;
    }): Promise<void>;
    defaultSlot: VNodeChildElement[];
    render?(props: Data<P>, state: Data<S>): VNodeChildElement;
    shouldUpdate?(oldState: S, newState: S): boolean;
    updatedCallback?(): void;
    emit(event: string, detail: any, options: EventInit): boolean;
}
export declare function mixin<P = {}, S = {}>(superClass?: {
    new (): HTMLElement;
    prototype: HTMLElement;
}): {
    new (): WebCellComponent<P, S>;
};
export {};
