import { VNodeChildElement } from './renderer';
export declare type PlainObject = {
    [key: string]: any;
};
declare function defineMetadata(key: string, value: any, target: Object): void;
declare function getMetadata(key: string, target: Object): any;
export declare const Reflect: {
    defineMetadata: typeof defineMetadata;
    getMetadata: typeof getMetadata;
};
export declare function toHyphenCase(raw: string): string;
export declare function toCamelCase(raw: string): string;
export declare function templateOf(tagName: string): any;
export declare function elementTypeOf(tagName: string): "html" | "xml";
export declare function delegate(selector: string, handler: Function): (this: Node, event: Event) => any;
export declare const documentReady: Promise<unknown>;
export declare function Fragment({ defaultSlot }: {
    defaultSlot?: VNodeChildElement[];
}): VNodeChildElement[] | undefined;
declare type LanguageMap<T> = {
    [K in keyof T]: string;
};
interface I18nData<T> {
    [language: string]: () => Promise<LanguageMap<T>>;
}
export declare function createI18nScope<T = {}>(data: I18nData<T>, defaultLanguage: string): {
    loaded: Promise<void>;
    i18nTextOf: (key: keyof T) => NonNullable<LanguageMap<T>>[keyof T] | undefined;
};
export {};
